__kernel void %KERNEL_NAME%(__global const int *src, __global uint *dst) {
  int tidX = get_global_id(0), tidY = get_global_id(1);
  int adr = (tidY << %SHIFT%)  + tidX;

  uint c = src[adr];

  uint r, g, b;

  if (c == 0) {
    r = g = b = 0;
  } else {
    r = (c & 1) == 0 ? 127 : 255;
    g = (c & 2) == 0 ? 127 : 255;
    b = (c & 4) == 0 ? 127 : 255;
  }

  dst[adr] = r | (g << 8) | (b << 16) | (255 << 24);
}
