package org.naokishibata.examples;

import java.awt.image.*;

import org.naokishibata.ocvimgio.*;
import org.naokishibata.generic.*;

public class CVTest {
    static boolean isAllZero(byte[] ptr) {
	for(int i=0;i<ptr.length;i++) {
	    if (ptr[i] != 0) return false;
	}

	return true;
    }

    public static void main(String[] args) throws Exception {
	Scribble2D s0 = null, s1 = null;

	CvCapture c0 = CvCapture.cvCreateCameraCapture(0);
	CvCapture c1 = CvCapture.cvCreateCameraCapture(1);

	if (c0 != null) {
	    c0.cvSetCaptureProperty(CvCapture.CV_CAP_PROP_FRAME_WIDTH , 640);
	    c0.cvSetCaptureProperty(CvCapture.CV_CAP_PROP_FRAME_HEIGHT, 480);
	    s0 = new Scribble2D();
	    s0.makeFrame("Camera 0");
	    s0.setExitWhenClosed(true);
	}

	if (c1 != null) {
	    c1.cvSetCaptureProperty(CvCapture.CV_CAP_PROP_FRAME_WIDTH , 640);
	    c1.cvSetCaptureProperty(CvCapture.CV_CAP_PROP_FRAME_HEIGHT, 480);
	    s1 = new Scribble2D();
	    s1.makeFrame("Camera 1");
	    s1.setExitWhenClosed(true);
	}

	for(;;) {
	    if (c0 != null) {
		IplImage iimg = c0.cvQueryFrame();

		if (iimg != null) {
		    BufferedImage bimg = iimg.getImage();
		    s0.drawImage(0, 0, bimg);
		}
	    }

	    if (c1 != null) {
		IplImage iimg = c1.cvQueryFrame();

		if (iimg != null) {
		    BufferedImage bimg = iimg.getImage();
		    s1.drawImage(0, 0, bimg);
		}
	    }

	    Thread.sleep(100);
	}
    }
}
